
import netscape.application.Color;

/*
 * This represents an arbitrary C/C++ Expression Statement
 */

public class DataBindTaskStatement extends DataStatement
{
	/* Class Constants. */
  public final static String   BIND_INDEX  = "BindIndex";
  public final static String   OPEN_PAREN  = "(";
  public final static String   TASK_VALUE  = "TaskValueIndex";
  public final static String   COMMA       = ",";
  public final static String   TASK_NAME   = "TaskNameIndex";
  public final static String   CLOSE_PAREN = ")";
  public final static String   SEMICOLON   = ";";

  public final static int      PARSE_GUI_BIND_TASK_STATEMENT = 5004;



	/* Class Variables */
  public       static Color    BIND_TASK_COLOR = Color.pink;


	/* Instance Variables */
  protected String           taskValueToBind;
  protected String           taskNameToBind;
  protected int              lineNumberOfTaskValueToBind;


	/* Instance Methods */
  public DataBindTaskStatement()
  {
    taskValueToBind             = null;
    taskNameToBind              = null;
    lineNumberOfTaskValueToBind = DataComponent.INVALID_LINE_NUMBER;
  }


  public boolean hasNullTaskValueToBind()
  {
    return taskValueToBind == null;
  }

  public String getTaskValueToBind()
  {
    if ( hasNullTaskValueToBind() )
      return "";
    else
      return taskValueToBind;
  }

  public void   setTaskValueToBind( String theTaskValueToBind )
  {
    taskValueToBind = theTaskValueToBind;
  }


  public boolean hasNullTaskNameToBind()
  {
    return taskNameToBind == null;
  }

  public String getTaskNameToBind()
  {
    if ( hasNullTaskNameToBind() )
      return getTaskValueToBind();
    else
      return taskNameToBind;
  }

  public void   setTaskNameToBind( String theTaskNameToBind )
  {
    taskNameToBind = theTaskNameToBind;
  }


  public void setLineNumberOfTaskValueToBind (
					  int theLineNumberOfTaskValueToBind )
	      { lineNumberOfTaskValueToBind = theLineNumberOfTaskValueToBind; }

  public int  getLineNumberOfTaskValueToBind()
					{ return lineNumberOfTaskValueToBind; }

  public boolean hasValidLineNumberOfTaskValueToBind()
  {
    return DataComponent.isValidLineNumber( getLineNumberOfTaskValueToBind() );
  }



  public DataComponent newComponent ( )
  {
    DataBindTaskStatement  statement = new DataBindTaskStatement();

    statement . addSubcomponent ( "\n" );
    statement . setIndex ( DataBindTaskStatement.BIND_INDEX );
    statement . setIndex ( DataBindTaskStatement.OPEN_PAREN );
    statement . setIndex ( DataBindTaskStatement.TASK_NAME );
    statement . setIndex ( DataBindTaskStatement.CLOSE_PAREN );
    statement . setIndex ( DataBindTaskStatement.SEMICOLON );

    return statement;
  }

  public String getWarnString ( int      theObjectSubset,
				boolean  theIsGenerating )
  {
    return super . getWarnString ( theObjectSubset, theIsGenerating )
	 + " or  DataBindTaskStatement.PARSE_GUI_BIND_TASK_STATEMENT ("
         + DataBindTaskStatement.PARSE_GUI_BIND_TASK_STATEMENT + ")";
  }

  public boolean isValidObjectSubset ( int      theObjectSubset,
				       boolean  theIsGenerating )
  {
    if ( theObjectSubset
	   == DataBindTaskStatement.PARSE_GUI_BIND_TASK_STATEMENT )
      return true;
    else
      return super . isValidObjectSubset ( theObjectSubset, theIsGenerating );
  }


  protected
    DataComponent parseSpecificComponent ( TDLParser theTDLParser,
					   int       theObjectSubsetToParse )
    throws Exception
  {
    warnIfInvalidObjectSubset ( theObjectSubsetToParse,
				"parseSpecificComponent", false );
    return theTDLParser . parseBindTaskStatement ( 0 );
  }


  public boolean setFrom ( DataComponent  theObjectToCopy,
			   int            theObjectSubsetToSet,
			   boolean        theCanDestroyObject  )
  {
    if ( /*NOT*/ !  ( theObjectToCopy instanceof DataBindTaskStatement ) )
    {
      System.err.println ( "[DataBindTaskStatement:setFrom]  Error:  "
			   + "Illegal object.  (\""
			   + theObjectToCopy . getClass() . getName()
			   + "\")" );
      return false;
    }

    DataBindTaskStatement theDataBindTaskStatementToCopy
			        = (DataBindTaskStatement) theObjectToCopy;
    boolean                  returnValue;


    setTaskValueToBind (
	       theDataBindTaskStatementToCopy . getTaskValueToBind() );

    setTaskNameToBind (
	       theDataBindTaskStatementToCopy . getTaskNameToBind() );


    returnValue =  super . setFrom ( theObjectToCopy, theObjectSubsetToSet,
				     theCanDestroyObject );


	/* Kludge to add "\n"'s to GUI-parsed jump-statements */
    if (   ( returnValue                                           == true   )
	&& ( theObjectSubsetToSet
	       == DataBindTaskStatement.PARSE_GUI_BIND_TASK_STATEMENT)
	&& ( getIndex ( DataBindTaskStatement.BIND_INDEX ) == 0      ))
    {
      addSubcomponent ( "\n", 0 );

      setIndex (            DataBindTaskStatement.BIND_INDEX,
		 getIndex ( DataBindTaskStatement.BIND_INDEX ) + 1 );

      setIndex (            DataBindTaskStatement.OPEN_PAREN,
		 getIndex ( DataBindTaskStatement.OPEN_PAREN ) + 1 );

      setIndex (            DataBindTaskStatement.TASK_NAME,
		 getIndex ( DataBindTaskStatement.TASK_NAME ) + 1 );

      setIndex (            DataBindTaskStatement.CLOSE_PAREN,
		 getIndex ( DataBindTaskStatement.CLOSE_PAREN ) + 1 );

      setIndex (            DataBindTaskStatement.SEMICOLON,
		 getIndex ( DataBindTaskStatement.SEMICOLON ) + 1 );

    }

    return returnValue;
  }


  public void generate ( DataDestination  theOutputDestination,
			 int              theObjectSubsetToGenerate )
  {
	/* Hack to deal with GUI-parsing... */
    if ( theObjectSubsetToGenerate
	   == DataBindTaskStatement.PARSE_GUI_BIND_TASK_STATEMENT )
      theObjectSubsetToGenerate = DataComponent . ENTIRE_OBJECT;

       	/* Print a warning if necessary... */
    warnIfInvalidObjectSubset ( theObjectSubsetToGenerate, "generate", true );

    	/* Initialize us to generate non-significant tokens... */
    initializeGenerateSubcomponentIndex();

	/* Generate any labels that we have... */
    generateLabels ( theOutputDestination, theObjectSubsetToGenerate,
		     DataBindTaskStatement.BIND_INDEX );

	/* Write any non-significant tokens before the task-registration... */
    generateSubcomponents ( DataBindTaskStatement.BIND_INDEX,
			    theOutputDestination,
			    theObjectSubsetToGenerate, false );

	/* If we are doing CXX generation... */
    if ( isCxxSubset ( theObjectSubsetToGenerate ) )
    {
      theOutputDestination . setNewlineText ( "    // " );
      theOutputDestination . write          ( "    // " );
    }

	/* Write out TDL_BIND */
    theOutputDestination . write ( DataComponent.TDL_BIND );


	/* Write any non-significant tokens before the open-paren */
    generateSubcomponents ( DataBindTaskStatement.OPEN_PAREN,
			    theOutputDestination,
			    theObjectSubsetToGenerate, false );

	/* Write out "(" */
    theOutputDestination . write ( DataBindTaskStatement.OPEN_PAREN );


	/* Write any non-significant tokens before the task-value */
    generateSubcomponents ( DataBindTaskStatement.TASK_VALUE,
			    theOutputDestination,
			    theObjectSubsetToGenerate, false );

	/* Write out task-value */
    theOutputDestination . write ( getTaskValueToBind() );


    if ( hasNullTaskNameToBind() == false )
    {
	/* Write any non-significant tokens before the comma */
      generateSubcomponents ( DataBindTaskStatement.COMMA,
			      theOutputDestination,
			      theObjectSubsetToGenerate, false );

	/* Write out "," */
      theOutputDestination . write ( DataBindTaskStatement.COMMA );


	/* Write any non-significant tokens before the task-name */
      generateSubcomponents ( DataBindTaskStatement.TASK_NAME,
			      theOutputDestination,
			      theObjectSubsetToGenerate, false );

	/* Write out task-name */
      theOutputDestination . write ( getTaskNameToBind() );
    }


	/* Write any non-significant tokens before the close-paren */
    generateSubcomponents ( DataBindTaskStatement.CLOSE_PAREN,
			    theOutputDestination,
			    theObjectSubsetToGenerate, false );

	/* Write out ")" */
    theOutputDestination . write ( DataBindTaskStatement.CLOSE_PAREN );


	/* Write any non-significant tokens before the semicolon... */
    generateSubcomponents ( DataBindTaskStatement.SEMICOLON,
			    theOutputDestination,
			    theObjectSubsetToGenerate, false );

	/* Write our semicolon */
    theOutputDestination . write ( DataBindTaskStatement.SEMICOLON );


	/* Write any remaining non-significant tokens */
	/* (There *SHOULD* *NOT* be any...  But just in case...) */
    generateAllRemainingSubcomponents ( theOutputDestination,
					theObjectSubsetToGenerate, false );

    
	/* If we are doing CXX generation... */
    if ( isCxxSubset ( theObjectSubsetToGenerate ) )
    {
      theOutputDestination . clearNewlineText();
      theOutputDestination . write ( "\n" );
      generateCxx ( theOutputDestination, theObjectSubsetToGenerate );
    }
  }

  public void generateCxx ( DataDestination  theOutputDestination,
			    int              theObjectSubsetToGenerate )
  {
    int tmpIndent = 0;

	/* Deal with #line macros */
    theOutputDestination . setUsingTdlFileName ( false );
    theOutputDestination . write ( "\n" ); /* This newline will be skipped.*/

	/* Write _TDL_SpawnedTasks . bindTCMTask ( theTask, "theTask" ); */
    theOutputDestination
      . write ( DataComponent.CXX_TDL_TASK_HANDLER_INSTANCE );
    theOutputDestination . write ( " . " );
    theOutputDestination
      . write ( DataComponent.CXX_TDL_TASK_HANDLER_BIND_TCM_TASK );
    theOutputDestination . write ( " ( " );
    
	/* Deal with #line macros */
    if ( theOutputDestination . getEnableLineMacros() )
    {
      tmpIndent = theOutputDestination . indentToCurrentColumn();
      theOutputDestination . setUsingTdlFileName ( true );
      theOutputDestination
	. makeNextLineNumber ( getLineNumberOfTaskValueToBind() );
      theOutputDestination . write ( "\n" );
    }

    theOutputDestination . write ( getTaskValueToBind() );
    theOutputDestination . write ( " , " );

	/* Deal with #line macros */
    if ( theOutputDestination . getEnableLineMacros() )
    {
      theOutputDestination . setUsingTdlFileName ( false );
      theOutputDestination . write ( "\n\"" );
      theOutputDestination . removeIndent ( tmpIndent );
    }
    else
    {
      theOutputDestination . write ( "\"" );
    }

    theOutputDestination . write ( getTaskNameToBind() );
    theOutputDestination . write ( "\" );\n" );
  }




  public boolean isSpawnRelatedStatement ( )
  {
    return true;
  }




	/********************************************************/
        /********** Methods to interface with Graphing **********/
	/********************************************************/
  public boolean supportsGraphType ( int theGraphType )
  {
    if (   ( theGraphType == GraphRoot.GUI_TREE_GRAPH ) )
      return true;
    else
      return false;
  }

  public GraphModule createGraphModule ( int theGraphType )
  {
    if (   ( theGraphType != GraphRoot.GUI_TREE_GRAPH ) )
      return null;

    /* else ... */

    /* Building:  +- "[.]"
     *            |
     */

    ScrollTextOfDataComponent  expressionText
				 = new ScrollTextOfDataComponent ( this,
		 DataBindTaskStatement.PARSE_GUI_BIND_TASK_STATEMENT );

    GraphNode       expressionNode = new GraphNode ( expressionText,
						     GraphComponent.LEFT,
						     DataExpressionStatement
						      . EXPRESSION_COLOR,
						     true, null );
						     
    GraphConnection toExpression = new GraphConnection( GraphComponent.LEFT,
							DataExpressionStatement
							 . EXPRESSION_COLOR,
							false, false,
							expressionNode );

    GraphMeet       startMeet = new GraphMeet ( GraphComponent.UP,
						DataExpressionStatement
						 . EXPRESSION_COLOR,
						GraphComponent.LEFT,
						toExpression );

    GraphConnection tail = new GraphConnection ( GraphComponent.UP,
					     DataComponent.getDraggableColor(),
					     true, true, null );
    startMeet . addChild ( tail );

    return new GraphModule ( startMeet, tail, null, null,
			     this, true, theGraphType );
  }


	/* Invoked by this.update(*) invoking GraphModule.update() */
  public boolean updateGraphModule ( DataComponent  theModifiedComponent,
				     Object         theStoredData,
				     GraphModule    theGraphModule )
  {
	/* There is nothing to do here.. */
    return true;
  }

}
